summaryrefslogtreecommitdiffstats
path: root/tools/perf/tests/shell/record.sh
diff options
context:
space:
mode:
authorIan Rogers <irogers@google.com>2022-04-13 18:46:42 -0700
committerArnaldo Carvalho de Melo <acme@redhat.com>2022-04-14 09:10:12 -0300
commit24f378e66021f559e90f2699e66581784718b2d9 (patch)
tree7bb1bfb6cec252d6e8f44e42df967136e30330ba /tools/perf/tests/shell/record.sh
parent2adacd7f0a9f88891acf667ce6957437051550eb (diff)
downloadlinux-stable-24f378e66021f559e90f2699e66581784718b2d9.tar.gz
linux-stable-24f378e66021f559e90f2699e66581784718b2d9.tar.bz2
linux-stable-24f378e66021f559e90f2699e66581784718b2d9.zip
perf test: Add basic perf record tests
Test the --per-thread flag. Test Intel machine state capturing. Suggested-by: Namhyung Kim <namhyung@kernel.org> Signed-off-by: Ian Rogers <irogers@google.com> Cc: Alexander Shishkin <alexander.shishkin@linux.intel.com> Cc: Alexey Bayduraev <alexey.bayduraev@gmail.com> Cc: Alexey Bayduraev <alexey.v.bayduraev@linux.intel.com> Cc: Andi Kleen <ak@linux.intel.com> Cc: Ingo Molnar <mingo@redhat.com> Cc: Jiri Olsa <jolsa@kernel.org> Cc: Mark Rutland <mark.rutland@arm.com> Cc: Peter Zijlstra <peterz@infradead.org> Cc: Riccardo Mancini <rickyman7@gmail.com> Cc: Stephane Eranian <eranian@google.com> Link: https://lore.kernel.org/r/20220414014642.3308206-3-irogers@google.com Signed-off-by: Arnaldo Carvalho de Melo <acme@redhat.com>
Diffstat (limited to 'tools/perf/tests/shell/record.sh')
-rwxr-xr-xtools/perf/tests/shell/record.sh42
1 files changed, 42 insertions, 0 deletions
diff --git a/tools/perf/tests/shell/record.sh b/tools/perf/tests/shell/record.sh
new file mode 100755
index 000000000000..cd1cf14259b8
--- /dev/null
+++ b/tools/perf/tests/shell/record.sh
@@ -0,0 +1,42 @@
+#!/bin/sh
+# perf record tests
+# SPDX-License-Identifier: GPL-2.0
+
+set -e
+
+err=0
+test_per_thread() {
+ echo "Basic --per-thread mode test"
+ perf record -e instructions:u --per-thread -o- true 2> /dev/null \
+ | perf report -i- -q \
+ | egrep -q true
+ echo "Basic --per-thread mode test [Success]"
+}
+
+test_register_capture() {
+ echo "Register capture test"
+ if ! perf list | egrep -q 'br_inst_retired.near_call'
+ then
+ echo "Register capture test [Skipped missing instruction]"
+ return
+ fi
+ if ! perf record --intr-regs=\? 2>&1 | egrep -q 'available registers: AX BX CX DX SI DI BP SP IP FLAGS CS SS R8 R9 R10 R11 R12 R13 R14 R15'
+ then
+ echo "Register capture test [Skipped missing registers]"
+ return
+ fi
+ if ! perf record -o - --intr-regs=di,r8,dx,cx -e cpu/br_inst_retired.near_call/p \
+ -c 1000 --per-thread true 2> /dev/null \
+ | perf script -F ip,sym,iregs -i - 2> /dev/null \
+ | egrep -q "DI:"
+ then
+ echo "Register capture test [Failed missing output]"
+ err=1
+ return
+ fi
+ echo "Register capture test [Success]"
+}
+
+test_per_thread
+test_register_capture
+exit $err